// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package auth_mobile

import (
	context "context"
	empty "github.com/golang/protobuf/ptypes/empty"
	auth_common "gitlab.com/adhocguru/fcp/apis/gen/accounting/v1/auth_common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MobileAuthServiceClient is the client API for MobileAuthService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MobileAuthServiceClient interface {
	SendCode(ctx context.Context, in *SendCodeRequest, opts ...grpc.CallOption) (*empty.Empty, error)
	CheckCode(ctx context.Context, in *CheckCodeRequest, opts ...grpc.CallOption) (*CheckCodeResponse, error)
	GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error)
	RegisterUser(ctx context.Context, in *RegisterUserRequest, opts ...grpc.CallOption) (*RegisterUserResponse, error)
	UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error)
	ValidateSession(ctx context.Context, in *ValidateSessionRequest, opts ...grpc.CallOption) (*ValidateSessionResponse, error)
}

type mobileAuthServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewMobileAuthServiceClient(cc grpc.ClientConnInterface) MobileAuthServiceClient {
	return &mobileAuthServiceClient{cc}
}

func (c *mobileAuthServiceClient) SendCode(ctx context.Context, in *SendCodeRequest, opts ...grpc.CallOption) (*empty.Empty, error) {
	out := new(empty.Empty)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/SendCode", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileAuthServiceClient) CheckCode(ctx context.Context, in *CheckCodeRequest, opts ...grpc.CallOption) (*CheckCodeResponse, error) {
	out := new(CheckCodeResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/CheckCode", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileAuthServiceClient) GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error) {
	out := new(auth_common.UserBriefInfo)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/GetUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileAuthServiceClient) RegisterUser(ctx context.Context, in *RegisterUserRequest, opts ...grpc.CallOption) (*RegisterUserResponse, error) {
	out := new(RegisterUserResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/RegisterUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileAuthServiceClient) UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*auth_common.UserBriefInfo, error) {
	out := new(auth_common.UserBriefInfo)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/UpdateUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileAuthServiceClient) ValidateSession(ctx context.Context, in *ValidateSessionRequest, opts ...grpc.CallOption) (*ValidateSessionResponse, error) {
	out := new(ValidateSessionResponse)
	err := c.cc.Invoke(ctx, "/fcp.accounting.v1.auth_mobile.MobileAuthService/ValidateSession", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MobileAuthServiceServer is the server API for MobileAuthService service.
// All implementations must embed UnimplementedMobileAuthServiceServer
// for forward compatibility
type MobileAuthServiceServer interface {
	SendCode(context.Context, *SendCodeRequest) (*empty.Empty, error)
	CheckCode(context.Context, *CheckCodeRequest) (*CheckCodeResponse, error)
	GetUser(context.Context, *GetUserRequest) (*auth_common.UserBriefInfo, error)
	RegisterUser(context.Context, *RegisterUserRequest) (*RegisterUserResponse, error)
	UpdateUser(context.Context, *UpdateUserRequest) (*auth_common.UserBriefInfo, error)
	ValidateSession(context.Context, *ValidateSessionRequest) (*ValidateSessionResponse, error)
	mustEmbedUnimplementedMobileAuthServiceServer()
}

// UnimplementedMobileAuthServiceServer must be embedded to have forward compatible implementations.
type UnimplementedMobileAuthServiceServer struct {
}

func (UnimplementedMobileAuthServiceServer) SendCode(context.Context, *SendCodeRequest) (*empty.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendCode not implemented")
}
func (UnimplementedMobileAuthServiceServer) CheckCode(context.Context, *CheckCodeRequest) (*CheckCodeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CheckCode not implemented")
}
func (UnimplementedMobileAuthServiceServer) GetUser(context.Context, *GetUserRequest) (*auth_common.UserBriefInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUser not implemented")
}
func (UnimplementedMobileAuthServiceServer) RegisterUser(context.Context, *RegisterUserRequest) (*RegisterUserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RegisterUser not implemented")
}
func (UnimplementedMobileAuthServiceServer) UpdateUser(context.Context, *UpdateUserRequest) (*auth_common.UserBriefInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateUser not implemented")
}
func (UnimplementedMobileAuthServiceServer) ValidateSession(context.Context, *ValidateSessionRequest) (*ValidateSessionResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ValidateSession not implemented")
}
func (UnimplementedMobileAuthServiceServer) mustEmbedUnimplementedMobileAuthServiceServer() {}

// UnsafeMobileAuthServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MobileAuthServiceServer will
// result in compilation errors.
type UnsafeMobileAuthServiceServer interface {
	mustEmbedUnimplementedMobileAuthServiceServer()
}

func RegisterMobileAuthServiceServer(s grpc.ServiceRegistrar, srv MobileAuthServiceServer) {
	s.RegisterService(&MobileAuthService_ServiceDesc, srv)
}

func _MobileAuthService_SendCode_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendCodeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).SendCode(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/SendCode",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).SendCode(ctx, req.(*SendCodeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileAuthService_CheckCode_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CheckCodeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).CheckCode(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/CheckCode",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).CheckCode(ctx, req.(*CheckCodeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileAuthService_GetUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).GetUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/GetUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).GetUser(ctx, req.(*GetUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileAuthService_RegisterUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RegisterUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).RegisterUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/RegisterUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).RegisterUser(ctx, req.(*RegisterUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileAuthService_UpdateUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).UpdateUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/UpdateUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).UpdateUser(ctx, req.(*UpdateUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileAuthService_ValidateSession_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ValidateSessionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileAuthServiceServer).ValidateSession(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.accounting.v1.auth_mobile.MobileAuthService/ValidateSession",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileAuthServiceServer).ValidateSession(ctx, req.(*ValidateSessionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// MobileAuthService_ServiceDesc is the grpc.ServiceDesc for MobileAuthService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var MobileAuthService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.accounting.v1.auth_mobile.MobileAuthService",
	HandlerType: (*MobileAuthServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SendCode",
			Handler:    _MobileAuthService_SendCode_Handler,
		},
		{
			MethodName: "CheckCode",
			Handler:    _MobileAuthService_CheckCode_Handler,
		},
		{
			MethodName: "GetUser",
			Handler:    _MobileAuthService_GetUser_Handler,
		},
		{
			MethodName: "RegisterUser",
			Handler:    _MobileAuthService_RegisterUser_Handler,
		},
		{
			MethodName: "UpdateUser",
			Handler:    _MobileAuthService_UpdateUser_Handler,
		},
		{
			MethodName: "ValidateSession",
			Handler:    _MobileAuthService_ValidateSession_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/auth_mobile/auth_service.proto",
}
